$(function(){
	//中心座標とタグID
	var CID = "#Central";
	
	var pox = 850;
	var poy = 100;
	//進行方向（right、left）
	var ScrollDirection = "right";	
	//タイマー　初期移動完了時間　ミリ秒（1は初期アニメーション無し）
	var TimerP = 1500;
	//タイマー　一コマ移動時間　ミリ秒（200以上の数字）
	var Timer = 300;
	//半径
	var radius = 1200;
	//円の傾き　奥行き(-89〜89)の数値で設定　45で正円、0で傾き無
	var slopeX = 45;	
	var slopeY = 4;
		
	//最初の画像の位置（0〜360） 最初の画像を90にセットすると正面に来る
	var setPosition = 90;
	//最大表示にする位置　90が正面（0〜359）
	var slopeF = 90;	
	//透過度の最低値（0.0〜1.0）
	var op = 0.4;
	//画像の縮小倍率（0.0〜1.0）
	var zo = 0.7;
	//画像の遠近効果（傾き）
	var perspective = true;
		
	$(CID).css({
		'width':'1px',
		'height':'1px',
		'position' : 'absolute',
		'top' : poy+'px',
		'left' : pox+'px'
	});
	
	
	
	var IiW = $(CID+' li:eq(0)').outerWidth();	
	var IiH = $(CID+' li:eq(0)').outerHeight();
	var IW = $(CID+' li:eq(0) img').outerWidth();	
	var IH = $(CID+' li:eq(0) img').outerHeight();

	$(CID+' ul').css({
		'position' : 'absolute',
		'top' : -poy-(IiH/2)+'px',
		'left' : -pox-(IiW/2)+'px'
	});

	//画像の数
	var max = $(CID+' li').length;
	if(max=='' || max==0){
		alert('画像がセットされていません。');
		return false;
	}
	
	//タイマーのチェック
	if(isNaN(Timer) || Timer < 200){
		Timer = 200;		
	}

	if(isNaN(TimerP) || TimerP <= 0){
		TimerP = 1;	
	}
	
	//画像の軌道配列作成
	var orbit = new Array();
		
	//背面の位置
	if(slopeF >= 180){
		var slopeB = Math.abs(slopeF - 180);	
	}else{
		var slopeB = slopeF + 180;
	}

	//軌道の各座標データの作成
	var sNmu = Math.abs(180 - slopeF);
	var lNum = 0;
	for(a=0; a<= 360;a++){
		orbit[a] = Array();
		
		//X座標
		x = Math.cos(a * Math.PI /180)*radius;
		if(-90<slopeX && slopeX<90){
			x = Math.tan(slopeX * Math.PI /180)*x;
		}
		x = Math.floor(x);
		orbit[a]['x'] = x+pox;
		
		//Y座標
		y = Math.sin(a * Math.PI /180)*radius;
		if(-90<slopeY && slopeY<90){
			y = Math.tan(slopeY * Math.PI /180)*y;
		}
		y = Math.floor(y);		
		orbit[a]['y'] = y+poy;

		if(slopeF < slopeB){
			if(a < slopeF){
				sNmu++;
			}else if(a < slopeB){
				sNmu--;
			}else{
				sNmu++;
			}			
		}else{
			if(a < slopeB){
				sNmu--;
			}else if(a < slopeF){
				sNmu++;
			}else{
				sNmu--;
			}			
		}
			
		//重ね順
		orbit[a]['i'] = sNmu+1;	
		opn = op + ((sNmu/180)*(1-op));	

		//透明度
		if(opn < 0){
			orbit[a]['o'] = 0;
		}else if(opn > 1){
			orbit[a]['o'] = 1;
		}else{
			orbit[a]['o'] = opn.toFixed(2);		
		}
		
		//画像の縮小
		zon = zo + ((sNmu/180)*(1-zo));	
		if(zon < 0){
			IWN = 0;
			IHN = 0;	
		}else if(zon > 1){
			IWN = IW;
			IHN = IH;
		}else{
			IWN = Math.floor(IW*zon);
			IHN = Math.floor(IH*zon);
		}
		orbit[a]['iw'] = IWN;
		orbit[a]['ih'] = IHN;

		
		//画像の遠近効果
		if(perspective == true){
			//横長の軌道の場合
			if(slopeX > slopeY){
				if(a <= 45){
					lNum++;	
				}else if(135 <= a && a < 180){
					lNum--;
				}else if(180 <= a && a < 225){
					lNum++;
				}else if(315 <= a && a <= 360){
					lNum--;
				}
		
				IWN = Math.floor((lNum/45) * IWN);
				if(IWN<=0){
					IWN =1;
				}	
				orbit[a]['iw'] = IWN;			
			}else{
			//縦長の軌道の場合
				if(45 <= a && a < 90){
					lNum++;	
				}else if(90 <= a && a < 135){
					lNum--;
				}else if(225 <= a && a < 270){
					lNum++;
				}else if(270 <= a && a < 315){
					lNum--;
				}
		
				IHN = IHN - Math.floor((lNum/45) * IHN);
				if(IHN<=0){
					IHN =1;
				}	
				orbit[a]['ih'] = IHN;					
			}		
		}
	}

	//各座標データの値の取得
	function getOrbitX(an){
		return orbit[an]['x'];
	}
	function getOrbitY(an){
		return orbit[an]['y'];
	}
	function getZindex(an){
		return orbit[an]['i'];
	}
	function getOpacity(an){
		return orbit[an]['o'];
	}
	function getZoomWidth(an){
		return orbit[an]['iw'];
	}
	function getZoomHeight(an){
		return orbit[an]['ih'];
	}

	//画像の初期配置	
	var an_n = Math.floor(360/max);
	var an;
	
	//画像の位置（角度）の配列情報
	//画像の初期配置
	var angles = new Array();
	var m = 0;	
	for(n=0 ; n<max ; n++){
		angles[n] = Array();
		an = an_n*n + setPosition;	
		if(an > 360){
			an = an -360;
		}
		setAngles(n,an);
	
		$(CID+' li:eq('+n+')').css({
			'position' : 'absolute',
			'top' : poy-(IiH/2)+'px',
			'left' : pox-(IiW/2)+'px'			
		});	
		
		x = getOrbitX(an);
		y = getOrbitY(an);
		i = getZindex(an);
		o = getOpacity(an);		
		iw = getZoomWidth(an);
		ih = getZoomHeight(an);	

		$(CID+' li:eq('+n+')').animate({
			'top' : y+'px',
			'left' : x+'px',
			//'z-index':i,
			'opacity':o
		},{
			queue: true,
			duration: TimerP,
			easing: "easeOutQuad",
			complete: function(){
				if(m == max-1){
					moveStart();
				}
				m++;	
			}
		});	

		$(CID+' li:eq('+n+') img').animate({
			'width' : iw+'px',
			'height' : ih+'px'
		},{
			queue: true,
			duration: TimerP,
			easing: "easeOutQuad",
			complete: function(){
			}
		});
	}
	
	//画像の角度データのセットと取得
	function setAngles(n,an){
		angles[n]['an'] = an;
	}
	function getAngles(n){
		return angles[n]['an'];
	}

	//画像の移動の制御
	var stopFlg = false;
	var speed = 1;
	function moveImage(n){		
		an = getAngles(n);
		//画像の切り替え
		if(an == slopeF && skipFlg == false){
			setCenterAction(n);
		}
				
		if(n==0){
			s = speed;
		}
		if(ScrollDirection =="right"){
			an = an + s;			
		}else{
			an = an - s;			
		}
		if(an >= 360){
			an = an -360;
		}else if(an < 0){
			an = an + 359;
		}
			
		x = getOrbitX(an);
		y = getOrbitY(an);
		i = getZindex(an);
		o = getOpacity(an);		
		iw = getZoomWidth(an);
		ih = getZoomHeight(an);
		setAngles(n,an);
		
		$(CID+' li:eq('+n+') img').animate({
			'width' : iw+'px',
			'height' : ih+'px'
		},{
			queue: true,
			duration: Timer*0.8,
			easing: "linear",
			complete: function(){
			}
		});	

		$(CID+' li:eq('+n+')').animate({
			'top' : y+'px',
			'left' : x+'px',
			//'z-index':i,
			'opacity':o
		},{
			queue: true,
			duration: Timer,
			easing: "linear",
			complete: function(){

				//画像が最大の時の処理
				if(an == slopeF && skipFlg==false){
		
				}
				
				//画像をクリックしたとき、画像のスライド処理	
				if(slidFlg == true && n==0){
					anc = getAngles(nc);
					if(anc == slopeF){
						//skipFlg = false;
						//slidFlg = false;						
						//setCenterAction(nc);;						
						moveStop();
					}else{					
						if(ScrollDirection =="right"){
							if(anc > slopeF){
								slidAangle = 360 - anc + slopeF;
							}else{
								slidAangle = slopeF - anc;
							}	
						}else{
							if(anc < slopeF){
								slidAangle = 360 - anc + slopeF;
							}else{
								slidAangle = anc - slopeF;
							}						
						}	
					}	

					if(slidAangle<=speed*2){
						speed = Math.floor(speed/2);
					}
					if(speed < 1){
						speed =1;
					}
				}

				if(stopFlg==false){
					moveImage(n);
				}
			}
		});
	}
	
	//開始
	function moveStart(){
		if(stopFlg == false){
			for(n=0 ; n<max ; n++){
				moveImage(n);
			}			
		}
	}

	//停止
	function moveStop(){
		stopFlg = true;	
		slidFlg = false;
		skipFlg =true;			
		speed = 1;	
	}

	//停止ボタンをクリックしたとき
	$('.ActionStop').bind('click',function(){
		moveStop();
	});
			
	//移動ボタンをクリックしたとき
	$('.ActionStart').bind('click',function(){	
		if(stopFlg == true){
			stopFlg = false;
			moveStart();		
		}
	});		

	//左回転ボタンを押したとき
	$('.MoveFromLeft').bind('click',function(){
		ScrollDirection = "left";
		if(stopFlg == true){
			stopFlg = false;
			moveStart();		
		}			
	});
	
	//右回転ボタンを押したとき
	$('.MoveFromRight').bind('click',function(){
		ScrollDirection = "right";
		if(stopFlg == true){
			stopFlg = false;
			moveStart();		
		}		
	});
	
	//速度UPボタンを押したとき
	$('.SpeedUp').bind('click',function(){
		skipFlg =true;		
		speed = 10;
		if(stopFlg == true){
			stopFlg = false;
			moveStart();		
		}			
	});
	
	//速度DOWNボタンを押したとき
	$('.SpeedDown').bind('click',function(){	
		skipFlg = false;		
		speed = 1;	
		if(stopFlg == true){
			stopFlg = false;
			moveStart();		
		}		
	});	

	//スキップボタンをマウスオーバーしたとき
	var skipFlg = false;
	$('.MoveSkip').hover(function(){
		skipFlg =true;
		speed = 15;
	},function(){
		skipFlg = false;
		speed = 1;		
	});
	
	//画像をクリックしたとき
	var slidFlg = false;
	var nc;
	var anc;
	var slidAangle;
	/*
	$(CID+' li').bind('click',function(){
		skipFlg =true;
		slidFlg = true;
	
		if(stopFlg == true){
			stopFlg = false;
			moveStart();		
		}
		nc= $(CID+' li').index(this);
		anc = getAngles(nc);
		
		if(slopeF < slopeB){
			if(anc < slopeF){
				ScrollDirection = "right";
			}else if(anc < slopeB){
				ScrollDirection = "left";
			}else{
				ScrollDirection = "right";
			}			
		}else{
			if(anc < slopeB){
				ScrollDirection = "left";
			}else if(anc < slopeF){
				ScrollDirection = "right";
			}else{
				ScrollDirection = "left";
			}			
		}
		speed = 20;	
	});	
	*/
	//画像が「setPosition」に来たときの処理
	//「n」が画像番号
	function setCenterAction(n){

	}

});

